<script setup lang="ts">
import { computed, defineEmits, reactive, ref } from 'vue'
import GitlabHelperApi from '@/api/gitlabHelperApi'
import UserApiV1 from '@/api/userApi'

const props = defineProps({
  gitlabIntegrationUser: {
    type: Object,
    default: () => ({
      git_id: '',
      git_username: '',
      token_id: '',
      token: '',
    }),
  },
})

const emit = defineEmits<Emit>()

interface Emit {
  (e: 'modified', value: number): void
}

const rGitlabIntUser = reactive(props.gitlabIntegrationUser)
const saving = ref(false)
const renewing = ref(false)
const deleting = ref(false)
const isRequest = ref(false)
const requestMessage = ref('')
const isTokenVisible = ref(false)

const groupProjectId = window.GITLAB_VENDOR_ID

const alertToggleVariant = computed(() => isError.value ? 'error' : 'success')
const alertToggleText = computed(() => isError.value ? 'Error!' : 'Success!')

const updateGitlabIntegrationUser = async () => {
  saving.value = true

  const userApi = new UserApiV1()

  console.log('responseUserData*** : ', rGitlabIntUser.user_id, rGitlabIntUser.token_id, rGitlabIntUser.token)
  try {
    const response = await userApi.updateGitUserToken(
      rGitlabIntUser.user_id,
      rGitlabIntUser.token_id,
      rGitlabIntUser.token,
    )

    rGitlabIntUser.git_id = response.data.data.git_id
    requestMessage.value = response.data.message
  }
  catch (error) {
    requestMessage.value = error.response.data.message
  }
  saving.value = false
  emit('modified')
}

const renewToken = async () => {
  let response
  renewing.value = true

  const gitlabHelper = new GitlabHelperApi()

  console.log('responseUserData*** : ', rGitlabIntUser.token_id, rGitlabIntUser.user_id, rGitlabIntUser.git_username)
  try {
    if (rGitlabIntUser.git_username.startsWith('g_token_')) {
      response = await gitlabHelper.renewGroupToken(
        groupProjectId,
        rGitlabIntUser.token_id,
        rGitlabIntUser.user_id,
      )
    }
    else {
      response = await gitlabHelper.renewGitLabToken(
        rGitlabIntUser.token_id,
        rGitlabIntUser.user_id,
        rGitlabIntUser.git_id,
        rGitlabIntUser.git_username,
      )
    }
    console.debug('renewToken response.data: ', response.data)
    rGitlabIntUser.token = response.data.data.token
    requestMessage.value = response.data.message
  }
  catch (error) {
    console.error('error*** : ', error)
    requestMessage.value = error.response.data.message
  }
  renewing.value = false
  emit('modified')
}

const deleteGitlabIntegrationUser = async () => {
  deleting.value = true

  const gitlabHelper = new GitlabHelperApi()

  console.log('responseUserData*** : ', rGitlabIntUser.user_id, rGitlabIntUser.token_id, rGitlabIntUser.token)
  try {
    const response = await gitlabHelper.deleteGitLabToken(
      rGitlabIntUser.token_id,
      rGitlabIntUser.user_id,
    )

    rGitlabIntUser.git_id = ''
    rGitlabIntUser.git_username = ''
    rGitlabIntUser.token_id = ''
    rGitlabIntUser.token = ''
    requestMessage.value = response.data.message
  }
  catch (error) {
    requestMessage.value = error.response.data.message
  }
  deleting.value = false
  emit('modified')
}
</script>

<template>
  <VForm class="mt-2">
    <VRow>
      <!-- 👉 ALERT -->
      <VCol cols="12">
        <VAlert
          v-if="isRequest"
          border="start"
          :border-color="alertToggleVariant"
          :color="alertToggleVariant"
          :type="alertToggleVariant"
          variant="tonal"
          dense
        >
          <VIcon left>
            tabler-alert-triangle
          </VIcon>
          {{ alertToggleText }}: {{ requestMessage }}
        </VAlert>
      </VCol>

      <!-- 👉 Gitlab user id -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.gitlabIntegrationUser.git_id"
          label="Gitlab user id"
          disabled
        />
      </VCol>

      <!-- 👉 Gitlab username -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.gitlabIntegrationUser.git_username"
          label="Gitlab username"
          disabled
        />
      </VCol>

      <!-- 👉 Gitlab token id -->
      <VCol
        cols="12"
        sm="6"
      >
        <VTextField
          v-model="props.gitlabIntegrationUser.token_id"
          label="Gitlab token id"
        />
      </VCol>

      <!-- 👉 Gitlab token -->
      <VCol
        cols="12"
        md="6"
      >
        <VTextField
          v-model="props.gitlabIntegrationUser.token"
          label="Gitlab token"
          placeholder="············"
          :type="isTokenVisible ? 'text' : 'password'"
          :append-inner-icon="isTokenVisible ? 'tabler-eye-off' : 'tabler-eye'"
          outlined
          dense
          @click:append-inner="isTokenVisible = !isTokenVisible"
        />
      </VCol>

      <!-- 👉 Save, Renew Token adn Delete Token Buttons -->
      <VCol cols="12">
        <VBtn
          color="primary"
          class="mr-2"
          :loading="saving"
          @click="updateGitlabIntegrationUser"
        >
          Save
        </VBtn>
        <VBtn
          color="primary"
          outlined
          class="mr-2"
          :loading="renewing"
          @click="renewToken"
        >
          Renew Token
        </VBtn>
        <VBtn
          color="red"
          class="mr-2"
          :loading="deleting"
          @click="deleteGitlabIntegrationUser"
        >
          Delete Token
        </VBtn>
      </VCol>
    </VRow>
  </VForm>
</template>
